Attribute VB_Name = "ModMain"

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

'GDI Function
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function StretchBlt Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Integer

Private Declare Sub InitCommonControls Lib "COMCTL32.DLL" ()

Public Declare Function SetErrorMode Lib "kernel32" (ByVal wMode As Long) As Long
Public Const SEM_FAILCRITICALERRORS = &H1
Public Const SEM_NOGPFAULTERRORBOX = &H2
Public Const SEM_NOOPENFILEERRORBOX = &H8000

' // WINAPI stuff for fast screen updates
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Declare Function StretchDIBits Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, lpBits As Any, lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

Public Type BITMAPINFOHEADER '40 bytes
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Public Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Public Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors(1) As RGBQUAD
End Type

Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0 '  color table in RGBs

Public bmiBuffer_UDG As BITMAPINFO
Public Min_Multiplier As Integer
Public CharMapBuff() As Byte
Public CurrChar As Integer
Public CurrCharBuff(7) As Byte
Public CopyBuff(7) As Byte
Public Mini_bmp(7) As Byte


Sub Main()

For a = 0 To 63
Ascii.ListImages.Add , "ICN" & a, TmpCharPic.Image
Next a

End Sub
Sub Load_UDG()
Dim ln As Long
Dim hFile As Integer

hFile = FreeFile

     Open App.path & "\DATAS\ZX_Original.Chr" For Binary Access Read Lock Read As #hFile
         ln = LOF(hFile)
         ReDim CharMapBuff(0 To ln - 1) As Byte
         Get #hFile, 1, CharMapBuff
    Close #hFile
'
End Sub

Sub Refresh_Dis(CharNumber As Integer)
Dim Char_offset As Integer, Y_off As Integer
Dim lTopMost As Long, lBottomMost As Long, lLeftMost As Long, lRightMost As Long
   
lTopMost = 8
lBottomMost = 0
lLeftMost = 8
lRightMost = 0
    
Char_offset = 8 * CharNumber

CopyMemory Mini_bmp(0), CharMapBuff(Char_offset), 8



Select Case CharNumber
Case 0 To 13
Y_off = 0 + 3
X_off = (8 * Min_Multiplier) * CharNumber + 3
Case 14 To 27
Y_off = 8 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 14) + 3
Case 28 To 41
Y_off = 16 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 28) + 3
Case 42 To 55
Y_off = 24 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 42) + 3
Case 56 To 64
Y_off = 32 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 56) + 3
End Select



UDG.Char_Picture.Visible = False

' StretchDIBits UDG.Char_Picture.hdc, lLeftMost, (lBottomMost + 1), (lRightMost - lLeftMost + 8), (lBottomMost - lTopMost + 1), lLeftMost, lTopMost, (lRightMost - lLeftMost) + 8, lBottomMost - lTopMost + 1, Mini_bmp(0), bmiBuffer_UDG, DIB_RGB_COLORS, SRCCOPY
 StretchDIBits UDG.Char_Picture.hdc, X_off, Y_off, 8 * Min_Multiplier, 8 * Min_Multiplier, 1, 1, 8, 8, Mini_bmp(0), bmiBuffer_UDG, DIB_RGB_COLORS, SRCCOPY


UDG.Char_Picture.Visible = True

'For Sub_offset = Char_offset To Char_offset + 8
'Next Sub_offset

End Sub
Public Sub CreateCharBuffer()
    bmiBuffer_UDG.bmiHeader.biSize = Len(bmiBuffer_UDG.bmiHeader)
    bmiBuffer_UDG.bmiHeader.biWidth = 8
    bmiBuffer_UDG.bmiHeader.biHeight = 8
    bmiBuffer_UDG.bmiHeader.biPlanes = 1
    bmiBuffer_UDG.bmiHeader.biBitCount = 1
    bmiBuffer_UDG.bmiHeader.biCompression = BI_RGB
    bmiBuffer_UDG.bmiHeader.biSizeImage = 0
    bmiBuffer_UDG.bmiHeader.biXPelsPerMeter = 200
    bmiBuffer_UDG.bmiHeader.biYPelsPerMeter = 200
    bmiBuffer_UDG.bmiHeader.biClrUsed = 0
    bmiBuffer_UDG.bmiHeader.biClrImportant = 0
    InitBitmapColors
End Sub
Public Sub InitBitmapColors()
    SetBitmapColor 0, &HFFFFFF
    SetBitmapColor 1, 0
End Sub

Public Sub SetBitmapColor(lIndex As Long, lColor As Long)
    If lIndex > 1 Then Exit Sub
    
    bmiBuffer_UDG.bmiColors(lIndex).rgbRed = (lColor And &HFF&)
    bmiBuffer_UDG.bmiColors(lIndex).rgbGreen = (lColor And &HFF00&) \ 256
    bmiBuffer_UDG.bmiColors(lIndex).rgbBlue = (lColor And &HFF0000) \ 65536
End Sub
Sub Paint_ap()
Dim pen_color As Long
Dim a, b

For a = 0 To 7
For b = 0 To 7
pen_color = UDG.Pixel((8 * a) + b).BackColor
SetPixel UDG.App.hdc, b * 2, a * 2, pen_color: SetPixel UDG.App.hdc, b * 2, (a * 2) + 1, pen_color
SetPixel UDG.App.hdc, (b * 2) + 1, a * 2, pen_color: SetPixel UDG.App.hdc, (b * 2) + 1, (a * 2) + 1, pen_color
Next b

Next a

End Sub
Sub Convert_Chr2Bin(ChrIndex As Integer)

Dim a, b, TmpSTR As String

For a = 0 To 7
TmpSTR = ""
For b = 0 To 7
If UDG.Pixel((8 * a) + b).BackColor = 0 Then TmpSTR = TmpSTR + "1" Else TmpSTR = TmpSTR + "0"
Next b
CurrCharBuff(a) = CByte(BinToDbl(TmpSTR))
CharMapBuff((ChrIndex * 8) + a) = CByte(BinToDbl(TmpSTR))
UDG.pokes(a).Caption = "B0" & Trim(Val(a)) & ":" & IIf(CharMapBuff((ChrIndex * 8) + a) < 16, "0", "") & Hex(CharMapBuff((ChrIndex * 8) + a)) & "h :" & CharMapBuff((ChrIndex * 8) + a)

Next a



End Sub

Sub Convert_Byte2Bin(ChrIndex As Integer)

Dim a, b, TmpSTR As String

For a = 0 To 7
TmpSTR = ConvBin(CLng(CharMapBuff((ChrIndex * 8) + a)), 8)
UDG.pokes(a).Caption = "B0" & Trim(Val(a)) & ":" & IIf(CharMapBuff((ChrIndex * 8) + a) < 16, "0", "") & Hex(CharMapBuff((ChrIndex * 8) + a)) & "h :" & CharMapBuff((ChrIndex * 8) + a)

For b = 0 To 7
If Mid(TmpSTR, b + 1, 1) = "1" Then
UDG.Pixel((8 * a) + b).BackColor = 0
Else
UDG.Pixel((8 * a) + b).BackColor = &HFFFFFF
End If

Next b
Next a

End Sub
Sub CopyChar(ChrIndex As Integer)

Dim a, b, TmpSTR As String

For a = 0 To 7
TmpSTR = ""
For b = 0 To 7
If UDG.Pixel((8 * a) + b).BackColor = 0 Then TmpSTR = TmpSTR + "1" Else TmpSTR = TmpSTR + "0"
Next b
CopyBuff(a) = CByte(BinToDbl(TmpSTR))
Next a

End Sub
Public Function ConvBin(Value As Double, Optional Longueur As Integer) As String
    
    On Error GoTo err
    'Convertir l'entier long en chane binaire
    ' Value#  - Entier long !(double prcision, pour viter les dbordements
    ' Longueur% - Longueur totale de la chane  gnrer
    '           (par exemple 32 caractres pour un entier long en 32 Bits)
    ' Bin$    - Chane binaire, par exemple "0100011101010", exploitation au niveau des bits
    'Ne travailler qu'avec des valeurs positives
    Dim X As Long, Y As Long, dummy As Double
    Dim max As Long, rest As Double
    Dim res As String, Resultat As String
    Dim bLen As Integer, RestLen As Integer
    
    Value = Abs(Value)
    X = -1
    While dummy <= Value
        X = X + 1
        dummy = 2 ^ X
    Wend
    max = X - 1
    rest = Value
    'Construire la chane binaire
    For Y = max To 0 Step -1
        rest = rest - (1 * 2 ^ Y)
        If rest >= 0 Then res$ = "1"
        If rest < 0 Then
            rest = rest + (1 * 2 ^ Y)
            res$ = "0"
        End If
        Resultat = Resultat + res
    Next Y
    If Resultat = "" Then Resultat = "0"
    'Retourner rsultat
    If Longueur = 0 Then
        'Retourtner rsultat (Longueur variable)
        ConvBin = Resultat
    Else
        'Complter  la longueur voulue (optionnel)
        bLen = Len(Resultat)
        RestLen = Longueur - bLen
        ConvBin = String(RestLen, "0") & Resultat
    End If
    Exit Function
err:
    ConvBin = 0
End Function
Function BinToDbl(Value As String) As Double
    'Convertir chane binaire en entier long
    '  Value$ - chane binaire , par exemple "0110101"
    '  Dez#   - Entier long (Type Double)
    Dim Dezimal As Double
    Dim MaxLen As Integer
    Dim b As Integer, X As Integer
  
    MaxLen = Len(Value)
    For X = 1 To MaxLen
        b = Val(Mid$(Value, X, 1))
        Dezimal = Dezimal + b * 2 ^ (MaxLen - X)
    Next
    BinToDbl = Dezimal
End Function


Sub SaveZxBasic(FileName As String, No_ligne As Integer)

     Dim a, b, Char_no, TmpSTR As String, hFile As Integer
     
     If No_ligne + 654 >= 9999 Then No_ligne = 9999 - 654
     hFile = FreeFile
     
On Error GoTo err_3
     Open FileName For Output Access Write Lock Write As #hFile
Print #hFile, No_ligne; "REM INIT UDG": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET UDG=(PEEK 16426*256)+PEEK 16425+5": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM XXXXXXXXXXXXXXXXXXXXXXXXXXXXX": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "FAST": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET C = 256": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET C$ = " & Chr(&H22) & "21001E110020010002EDB0210022363E2336202336ED2336472336C9C900" & Chr(&H22): No_ligne = No_ligne + 1
Print #hFile, No_ligne; "FOR R = UDG TO UDG + 28": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "POKE R,CODE C$(1)*16+CODE C$(2)-476": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET C$=C$(3 TO )": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "NEXT R": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "RAND USR UDG": No_ligne = No_ligne + 1

 For Char_no = 0 To 63

Print #hFile, No_ligne; "REM CHAR: -"; Char_no; "-": No_ligne = No_ligne + 1

For a = 0 To 7
Print #hFile, No_ligne; "POKE "; Trim(Val(8192 + (8 * Char_no) + a)); ", "; Trim(Val(CharMapBuff((Char_no * 8) + a))): No_ligne = No_ligne + 1
Next a

Next Char_no
Print #hFile, No_ligne; "RAND USR 8704": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "SLOW": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "RETURN"
     Close #hFile
    
err_3:
End Sub

Sub SaveZxBasicREM(FileName As String, No_ligne As Integer)

     Dim a, b, Char_no, TmpSTR As String, hFile As Integer
     
     If No_ligne + 654 >= 9999 Then No_ligne = 9999 - 654
     hFile = FreeFile
     
On Error GoTo err_3
     Open FileName For Output Access Write Lock Write As #hFile
Print #hFile, No_ligne; "REM INIT UDG": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET UDG=(PEEK 16426*256)+PEEK 16425+5": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM ";: No_ligne = No_ligne + 1
For a = 0 To 541
Print #hFile, "X";
Next a
Print #hFile,
Print #hFile, No_ligne; "FAST": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM LES LIGNE SUIVANTES": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM PEUVENT ETRE EFFACEES": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM APRES EXECUTION DU PROGRAMME": No_ligne = No_ligne + 1

Print #hFile, No_ligne; "LET C = 256": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET C$ = " & Chr(&H22) & "21001E110020010002EDB0210022363E2336202336ED2336472336C9C900";

For Char_no = 0 To 30
For a = 0 To 7
Var_UDG = CharMapBuff((Char_no * 8) + a)
Select Case Var_UDG
Case 0
Print #hFile, ; "00";
Case Is > 0 And Var_UDG < &H10
Print #hFile, ; "0"; Trim(Hex(Var_UDG));
Case Else
Print #hFile, ; Trim(Hex(Var_UDG));
End Select
Next a
Next Char_no
Print #hFile, Chr(&H22)
No_ligne = No_ligne + 1

Print #hFile, No_ligne; "LET C$ = C$ +" & Chr(&H22);

For Char_no = 31 To 63
For a = 0 To 7
Var_UDG = CharMapBuff((Char_no * 8) + a)
Select Case Var_UDG
Case 0
Print #hFile, ; "00";
Case Is > 0 And Var_UDG < &H10
Print #hFile, ; "0"; Trim(Hex(Var_UDG));
Case Else
Print #hFile, ; Trim(Hex(Var_UDG));
End Select

Next a
Next Char_no

Print #hFile, Chr(&H22)
No_ligne = No_ligne + 1
Print #hFile, No_ligne; "FOR R = UDG TO UDG + 540": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "POKE R,CODE C$(1)*16+CODE C$(2)-476": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET C$=C$(3 TO )": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "NEXT R": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "REM --- FIN DES LIGNES A EFFACER": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "LET OFFSET=UDG+29": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "POKE UDG+2,INT(OFFSET/256)": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "POKE UDG+1,OFFSET-256*(INT(OFFSET/256))": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "RAND USR UDG": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "RAND USR 8704": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "SLOW": No_ligne = No_ligne + 1
Print #hFile, No_ligne; "RETURN"
     Close #hFile
    
err_3:
End Sub

Sub SaveLoader(FileName As String)
     Dim Fbuffer() As Byte
     Dim hFile As Integer
     
     
On Error GoTo err_3
     hFile = FreeFile
     Open App.path & "\DATAS\Blank-LOADER.BIN" For Binary Access Read Lock Write As #hFile
     ReDim Fbuffer(0 To LOF(hFile) - 1)
     Get #hFile, 1, Fbuffer
     Close #hFile
     
     CopyMemory Fbuffer(1401), CharMapBuff(0), 512
     
     hFile = FreeFile
     Open FileName For Binary Access Write Lock Read As #hFile
     Put #hFile, 1, Fbuffer
     Close #hFile
 
     
err_3:
End Sub
